/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vsb.vis.visvzorservice;

import cz.vsb.vis.visvzor.model.Clovek;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class LideRepositoryJdbcImpl implements LideRepository {

    private final String password;
    private final String userName;
    private final String url;

    public LideRepositoryJdbcImpl(String url, String userName, String password) {
        this.url = url;
        this.userName = userName;
        this.password = password;
    }

    @Override
    public List<Clovek> nactiLidi() {
        List<Clovek> lide = new ArrayList<>();
        try (Connection connection = DriverManager.getConnection(url, userName, password);
                Statement st = connection.createStatement();
                ResultSet rs = st.executeQuery("select * from osoba")) {
            while (rs.next()) {
                Clovek clovek = new Clovek(rs.getString("jmeno"), rs.getString("prijmeni"));
                lide.add(clovek);
            }
        } catch (SQLException ex) {
            Logger.getLogger(LideRepositoryJdbcImpl.class.getName()).log(Level.SEVERE, null, ex);
        }
        return lide;
    }

    @Override
    public void ulozClovek(Clovek clovek) throws FileNotFoundException, UnsupportedEncodingException {
        try (Connection connection = DriverManager.getConnection(url, userName, password);
                PreparedStatement ps = connection.prepareStatement("insert into osoba (jmeno,prijmeni) values (?,?)")) {

            ps.setString(1, clovek.getJmeno());
            ps.setString(2, clovek.getPrijmeni());
            int numberOfUpdated = ps.executeUpdate();
            if (numberOfUpdated != 1) {
                throw new SQLException("Ulozeni se nepodarilo");
            }
        } catch (SQLException ex) {
            Logger.getLogger(LideRepositoryJdbcImpl.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
